/**
 * 
 */
package org.springblade.dto;

import java.io.Serializable;

import lombok.Data;

/**
 * @author wookvn
 *
 */
@Data
public class Result<T> implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public final static int SC_OK = 200;
	public final static int SC_BAD_REQUEST = 500;

	private int code = SC_OK;
	
	private T data;
	
	private String message;
	
	private String ext;
	
	
	public static <T> Result<T> success(T data){
		return new Result<>(SC_OK, data, "成功", null);
	}
	
	public static <T> Result<T> failure(String message){
		return new Result<>(SC_BAD_REQUEST, null, message, null);
	}

	public static <T> Result<T> failure(String message, String ext){
		return new Result<>(SC_BAD_REQUEST, null, message, ext);
	}

	/**
	 * @param code
	 * @param data
	 * @param message
	 */
	public Result(int code, T data, String message, String ext) {
		super();
		this.code = code;
		this.data = data;
		this.message = message;
		this.ext = ext;
	}


	/**
	 * 
	 */
	public Result() {
		super();
	}
}
