/**
 * 
 */
package org.springblade.dto;

import java.io.Serializable;
import java.util.List;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import lombok.Data;

/**
 * @author wookvn
 *
 */
@Data
public class ScreenShotParam implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	//域名地址
//	private String homeUrl;
	
	//token
	private String token;
	
	//水印说明
	private String text = "保密";
	
	//水印参数
	private Integer watermark = 1;
	
	private List<Site> site;
	
	@Data
	public static class Site{
		//大屏ID
		private String id;
		//大屏地址
		private String url;
		//宽、高、模式
		private JSONObject content;
		
		/**
		 * 获取高度
		 * @return
		 */
		public int height() {
			//quick模式
			if("quick".equalsIgnoreCase(content.getStr("type"))) {
				//计算高度
				JSONArray jsonArray = content.getJSONArray("layout");
				int height = 0;
				for(JSONObject item : jsonArray.jsonIter()) {
					height += item.getInt("h", 0) * 48;
				}
				return height + jsonArray.size() * 48;
			}else {
				return content.getInt("height", 2000);
			}
		}
		
		/**
		 * 获取宽度
		 * @return
		 */
		public int width() {
			return content != null ? content.getInt("width", 1920) : 1920;
		}
	}
}
