/**
 * 
 */
package org.springblade.pool;

import org.apache.commons.pool2.PooledObjectFactory;
import org.apache.commons.pool2.impl.AbandonedConfig;
import org.apache.commons.pool2.impl.GenericObjectPool;
import org.apache.commons.pool2.impl.GenericObjectPoolConfig;

import com.microsoft.playwright.BrowserContext;

import lombok.extern.slf4j.Slf4j;

/**
 * @author wookvn
 *
 */
@Slf4j
public class BrowserContextObjectPool extends GenericObjectPool<BrowserContext> {

	public BrowserContextObjectPool(PooledObjectFactory<BrowserContext> factory) {
		super(factory);
	}

	public BrowserContextObjectPool(PooledObjectFactory<BrowserContext> factory,
			GenericObjectPoolConfig<BrowserContext> config, AbandonedConfig abandonedConfig) {
		super(factory, config, abandonedConfig);
	}

	public BrowserContextObjectPool(PooledObjectFactory<BrowserContext> factory,
			GenericObjectPoolConfig<BrowserContext> config) {
		super(factory, config);
	}

	public BrowserContextObjectPool initPool() {
		log.info("正在初始化browserContext");
		int initialSize = this.getMinIdle(), maxIdle = this.getMaxIdle();
		if (initialSize <= 0) {
			return this;
		}

		int size = Math.min(initialSize, maxIdle);
		for (int i = 0; i < size; i++) {
			try {
				this.addObject();
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}
		return this;
	}
}
